aioitertools
============

[![Generated by attribution][attribution-badge]][attribution-url]


v0.12.0
-------

Feature release

- New: added `itertools.batched()` from Python 3.13 (#177)
- New: added `builtins.tuple()` (#152)
- Docs: fixed rendering of shell sections (#183)
- Python: added support for 3.12 and 3.13 (#154, #192)
- Python: dropped support for 3.6 and 3.7 (#154)
- Dev: updated gitignore and contributing guide (#176, #192)
- Dev: use `uv` for creating venv and installing deps when available (#192)

```text
$ git shortlog -s v0.11.0...v0.12.0
     7	Amethyst Reese
     1	Julian Gilbey
     2	Stanley Kudrow
     1	Vlastimil Zíma
    17	dependabot[bot]
```


v0.11.0
-------

Feature release

- New: `before_and_after` from `more_itertools` (#111)
- Removed: `loop` parameter is now removed from asyncio functions (#136)
- Docs: fixed docstring for `builtins.max` (#107)
- Docs: can now be built without installing package (#135)
- Python: Added support for Python 3.11 (#133)
- Python: Deprecated support for Python 3.6, to be removed in 0.12.0

```text
$ git shortlog -s v0.10.0...v0.11.0
    16	Amethyst Reese
     2	Daniel Miranda
     1	Minsung.Kim
    12	dependabot[bot]
```


v0.10.0
-------

Feature release

- New `as_generated()` function for consuming multiple iterables (#99)

```text
$ git shortlog -s v0.10.0b1...v0.10.0
     1	Amethyst Reese
```


v0.10.0b1
---------

Beta release

- New `as_generated()` function for consuming multiple iterables (#99)

```text
$ git shortlog -s v0.9.0...v0.10.0b1
     3	Amethyst Reese
```


v0.9.0
------

Feature release

- Python 3.10 support (#84, #97)
- Fixed: `as_completed()` will now cancel pending tasks when the timeout
  threshold has been reached.
- Fixed: `zip()` will now gather all tasks correctly when exceptions are
  raised, resulting in no pending tasks being unawaited.
- DEPRECATED: `loop` parameters to asyncio functions are ignored, and will
  be removed entirely in v0.11.0. This is for 3.10 compatibility, as well
  as to follow common practice and guidance around asyncio.

```text
$ git shortlog -s v0.8.0...v0.9.0
    17	Amethyst Reese
    20	dependabot[bot]
     3	pyup.io bot
```


v0.8.0
------

Feature release:

- Added `builtins.any()` and `builtins.all()` (#44)
- `builtins.next()` takes an optional `default` parameter (#40, #41)
- `asyncio.gather()` now handles cancellation (#64)
- Better exception handling in `itertools.tee()` (#47)
- Removed dependency on typing_extensions for Python 3.8 and newer (#49)
- Improved documentation and formatting

```text
$ git shortlog -s v0.7.1...v0.8.0
    15	Amethyst Reese
     1	Bryan Forbes
     2	Jason Fried
     1	Kevin Stone
     3	Roger Aiudi
     3	Sunyeop Lee
     1	Yop
    10	pyup.io bot
```


v0.7.1
------

Bugfix release:

* Fix groupby() not working with empty iterables (#39)
* Tested on Python 3.9

```text
$ git shortlog -s v0.7.0...v0.7.1
     8	Amethyst Reese
     1	Roger Aiudi
     2	pyup-bot
```


v0.7.0
------

Feature release

- Add `min()` and `max()` to builtins

```text
$ git shortlog -s v0.6.1...v0.7.0
     7	Amethyst Reese
```


v0.6.1
------

Metadata fix

- Corrected description field for PyPI
- Switched from setuptools to flit for build/publish

```text
$ git shortlog -s v0.6.0...v0.6.1
     6	Amethyst Reese
     1	Dima Tisnek
```


v0.6.0
------

Feature release v0.6.0

- First pieces of more_itertools (#18)

```text
$ git shortlog -s v0.5.1...v0.6.0
     3	Amethyst Reese
     1	Zsolt Dollenstein
```


v0.5.1
------

Documentation Release v0.5.1

- Include changelog, code of conduct, and contributers guide in sdist
- Include wheels when building release distributions

```text
$ git shortlog -s v0.5.0...v0.5.1
     4	Amethyst Reese
```


v0.5.0
------

Feature Release v0.5.0

- Feature: concurrency-limited implementation of asyncio.gather (#10)
- Fix: platform independent encoding in setup.py (#15, #16)
- Fix: make zip_longest stop iterating on finished iterators (#13)
- Improved documentation
- Overhaul package configuration and requirements
- Format package using isort
- Add coverage testing with codecov.io
- Switch to Github Actions for CI
- Testing on Python 3.8

```text
$ git shortlog -s v0.4.0...v0.5.0
     1	Alexey Simuskov
    23	Amethyst Reese
     1	Tim Hatch
```


v0.4.0
------

Feature release v0.4.0

- Provisional module for friendly versions of the asyncio library.
  Access this via `aioitertools.asyncio`.

```text
$ git shortlog -s v0.3.2...v0.4.0
     4	Amethyst Reese
```


v0.3.2
------

Bug fix release:

- chain.from_iterable now accepts async generators to provide iterables (#8)

```text
$ git shortlog -s v0.3.1...v0.3.2
     1	A Connecticut Princess
     2	Amethyst Reese
```


v0.3.1
------

Bug fix release v0.3.1:

- Fixes `islice` consuming extra items (#7)

```text
$ git shortlog -s v0.3.0...v0.3.1
     2	Amethyst Reese
     3	Vladimir Solomatin
```


v0.3.0
------

Feature release v0.3.0:

- Accept `start` parameter to `enumerate()` (#2)
- Added PEP 561 compliance and py.typed (#1)
- Support for functions that return awaitables (#5)

```text
$ git shortlog -s v0.2.0...v0.3.0
    12	Amethyst Reese
     6	Bryan Forbes
```


v0.2.0
------

Feature release:

- Support all of itertools

```text
$ git shortlog -s v0.1.0...v0.2.0
     8	Amethyst Reese
```


v0.1.0
------

Initial feature release:

- Shadow major builtins for iterables
- Unit tests for all builtins

```text
$ git shortlog -s v0.1.0
     2	Amethyst Reese
```

[attribution-badge]:
    https://img.shields.io/badge/generated%20by-attribution-informational
[attribution-url]: https://attribution.omnilib.dev
